
%%

%public
%class ScannerJF
%function token
%type Token
%line
%state CPASCAL
%state JAVA

%{
int nivel = 0;
%}

%%

[ \n\t]    { }  // pula espaços em branco

<CPASCAL> {
  [(][*]   { nivel++; }
  [*][)] { if(--nivel == 0) yybegin(YYINITIAL); }
  . | "\n"  { }
}

<YYINITIAL> {

[(][*] { nivel++; yybegin(CPASCAL); } 

[-][-].* { System.out.println("comentário2"); } // pula comentários de uma linha

[0-9]+  { return new Token(Token.NUM, yytext(), yyline); }

[pP][rR][iI][nN][tT]    { return new Token(Token.PRINT, yytext(), yyline); }

[a-zA-Z][a-zA-Z0-9_]*     { return new Token(Token.ID, yytext(), yyline); }

[{]     { yybegin(JAVA); }

}

<JAVA> {

[/][*]~[*][/] { System.out.println("comentário1"); } // pula comentários

[/][/].* { System.out.println("comentário2"); } // pula comentários de uma linha

[0-9]+  { return new Token(Token.NUM, yytext(), yyline); }

"println"    { return new Token(Token.PRINT, yytext(), yyline); }

[a-zA-Z][a-zA-Z0-9_]*     { return new Token(Token.ID, yytext(), yyline); }

[}]     { yybegin(YYINITIAL); }

}

<<EOF>>    { return new Token(Token.EOF, "<<EOF>>", yyline); }

.          { return new Token(yytext().charAt(0), yytext(), yyline); }

